# Changelog

<!--
### ✨ Feature
### 🤏 Minor change
### 🎨 Interface
### 🐛 Bugfix
### 🔒 Security
### 🚀‍️ CI / CD
### 🔨 Internal / Developers
### 📚 Documentation

**💥 Breaking:**
**⚠️ Deprecation:**

### 🔨 Internal / Developers
- No modifications / Keep major and minors versions in sync with all parts of the project
-->


## 6.0.0 (Upcoming)

### ✨ Feature
- Add SonarQube integration for exercises (thanks to @joel.vonderwe)

### 🔨 Internal / Developers
- Major dependencies update


## 5.0.0 (2024-10-21)

### ✨ Feature
- Add possibility of self-host the solution


## 4.2.0 (2024-07-05)
- No modifications / Keep major and minors versions in sync with all parts of the project


## 4.1.1 (2024-05-28)

### 🐛 Bugfix
- Remove node warning messages


## 4.1.0 (2024-05-28)
- No modifications / Keep major and minors versions in sync with all parts of the project


## 4.0.0 (2024-04-19)

### 🔨 Internal / Developers
- SonarQube integration
- Migration to GitBreaker library for all Gitlab API calls
- Dependencies update


## 3.5.0 (2024-02-26)
- No modifications / Keep major and minors versions in sync with all parts of the project


## 3.4.0 (2024-01-23)
- No modifications / Keep major and minors versions in sync with all parts of the project


## 3.3.0 (2024-01-18)

### ✨ Feature
- Add a new optional field on `results.json` file to provide some flexible informations display for the teaching staff


## 3.2.0 (2024-12-19)
- No modifications / Keep major and minors versions in sync with all parts of the project


## 3.1.0 (2023-12-06)

### 🔨 Internal / Developers
- **Typescript**: Add linter (ESLint)


## 3.0.0 (2023-11-03)

### 🔨 Internal / Developers
- No modifications / Keep major and minors versions in sync with all parts of the project


## 2.2.0 (2023-10-16)

### ✨ Feature
- `results.json` file is now optional (if the teaching staff don't want to provide test details)
    - The exercise will be considered as valid if the container exit code is 0
    - The `results.json` file will be construct / completed with the container exit code
    - The `volume` argument of `dojo_assignment.json` is now optional (if the teaching staff don't want to provide `results.json` file or other files)

### 🔨 Internal / Developers
- Enhancement in pipelines by splitting them into several files


## 2.1.0 (2023-09-29)

### 🎨 Interface
- **💥 Breaking:** Renamed `dojo.enonce` (or `dojo.assignment`) file to `dojo_assignment.json`

### 🔨 Internal / Developers
- Deploy Wiki on Gitlab (on push to `main`) from files of `Wiki` folder
- Migration from .env files stored in Gitlab Secure Files to usage of `dotenv-vault` (locally)

### 📚 Documentation
- Added Wiki base


## 2.0.0 (2023-09-15)

### ✨ Feature
- Added license: AGPLv3

### 🎨 Interface
- **💥 Breaking:** Renamed `enonce` to `assignment`
- **💥 Breaking:** Renamed `exercice` to `exercise`

### 🔨 Internal / Developers
- Auto release by pipeline
    - For vX.Y.Z branch create release and tag with `-dev` suffix
    - For main branch create definitive release and remove `-dev` releases


## 1.0.1 (2023-08-12)

### ✨ Feature
- 🎉 Initial release of the project